받은 편지함 규칙 업데이트

Note: This endpoint is in Preview and is subject to change. If you have any feedback, contact Datadog support.

PUT https://api.ap1.datadoghq.com/api/v2/security/findings/automation/inbox_rules/{rule_id}https://api.ap2.datadoghq.com/api/v2/security/findings/automation/inbox_rules/{rule_id}https://api.datadoghq.eu/api/v2/security/findings/automation/inbox_rules/{rule_id}https://api.ddog-gov.com/api/v2/security/findings/automation/inbox_rules/{rule_id}https://api.us2.ddog-gov.com/api/v2/security/findings/automation/inbox_rules/{rule_id}https://api.uk1.datadoghq.com/api/v2/security/findings/automation/inbox_rules/{rule_id}https://api.datadoghq.com/api/v2/security/findings/automation/inbox_rules/{rule_id}https://api.us3.datadoghq.com/api/v2/security/findings/automation/inbox_rules/{rule_id}https://api.us5.datadoghq.com/api/v2/security/findings/automation/inbox_rules/{rule_id}

개요

Update an inbox rule by ID. This endpoint requires the security_pipelines_write permission.

인수

경로 파라미터

이름

유형

설명

rule_id [required]

string

The ID of the inbox rule.

요청

Body Data (required)

Expand All

항목

유형

설명

data [required]

object

The data object for an inbox rule update request. The id must match the rule_id path parameter.

attributes [required]

object

Attributes for creating or updating an inbox rule.

action [required]

object

The action to take when the inbox rule matches a finding.

description

string

An optional description providing more context for the rule.

enabled

boolean

Whether the inbox rule is enabled.

name [required]

string

The name of the inbox rule.

rule [required]

object

Defines the scope of findings to which the automation rule applies.

finding_types [required]

[string]

The list of security finding types that the automation rule applies to.

query

string

A search query to further filter the findings matched by this rule. The @workflow.* namespace and @status fields are not permitted. For a reference of available fields, see the Security Findings schema documentation.

id [required]

uuid

The ID of the inbox rule to update.

type [required]

enum

The JSON:API type for inbox rules. Allowed enum values: inbox_rules

{
  "data": {
    "attributes": {
      "action": {
        "description": "Needs triage"
      },
      "enabled": false,
      "name": "Example-Security-Monitoring",
      "rule": {
        "finding_types": [
          "misconfiguration"
        ],
        "query": "env:staging"
      }
    },
    "id": "00000000-0000-0000-0000-000000000000",
    "type": "inbox_rules"
  }
}

응답

Successfully updated the inbox rule

A single inbox rule response.

Expand All

항목

유형

설명

data [required]

object

The data object for an inbox rule returned by the API.

attributes [required]

object

Attributes of an inbox rule returned by the API.

action [required]

object

The action to take when the inbox rule matches a finding.

description

string

An optional description providing more context for the rule.

created_at [required]

int64

The Unix timestamp in milliseconds when the rule was created.

created_by [required]

object

The user or Datadog system who created the rule.

id [required]

string

The actor's identifier (a user UUID or a system identifier).

name [required]

string

The name of the actor.

type [required]

enum

Whether the actor is a user or the Datadog system. Allowed enum values: user,system

enabled [required]

boolean

Whether the inbox rule is enabled.

modified_at [required]

int64

The Unix timestamp in milliseconds when the rule was last modified.

modified_by [required]

object

The user or Datadog system who last modified the rule.

id [required]

string

The actor's identifier (a user UUID or a system identifier).

name [required]

string

The name of the actor.

type [required]

enum

Whether the actor is a user or the Datadog system. Allowed enum values: user,system

name [required]

string

The name of the inbox rule.

rule [required]

object

Defines the scope of findings to which the automation rule applies.

finding_types [required]

[string]

The list of security finding types that the automation rule applies to.

query

string

A search query to further filter the findings matched by this rule. The @workflow.* namespace and @status fields are not permitted. For a reference of available fields, see the Security Findings schema documentation.

id [required]

uuid

The ID of the inbox rule.

type [required]

enum

The JSON:API type for inbox rules. Allowed enum values: inbox_rules

{
  "data": {
    "attributes": {
      "action": {
        "description": "Needs triage"
      },
      "created_at": 1722439510282,
      "created_by": {
        "id": "00000000-0000-0000-0000-000000000000",
        "name": "Jane Doe",
        "type": "user"
      },
      "enabled": true,
      "modified_at": 1722439510282,
      "modified_by": {
        "id": "00000000-0000-0000-0000-000000000000",
        "name": "Jane Doe",
        "type": "user"
      },
      "name": "Triage production misconfigurations",
      "rule": {
        "finding_types": [
          "misconfiguration"
        ],
        "query": "env:prod team:platform"
      }
    },
    "id": "00000000-0000-0000-0000-000000000000",
    "type": "inbox_rules"
  }
}

Bad Request

API error response.

Expand All

항목

유형

설명

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Forbidden

API error response.

Expand All

항목

유형

설명

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Not Found

API error response.

Expand All

항목

유형

설명

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

Unprocessable Entity

API error response.

Expand All

항목

유형

설명

errors [required]

[object]

A list of errors.

detail

string

A human-readable explanation specific to this occurrence of the error.

meta

object

Non-standard meta-information about the error

source

object

References to the source of the error.

header

string

A string indicating the name of a single request header which caused the error.

parameter

string

A string indicating which URI query parameter caused the error.

pointer

string

A JSON pointer to the value in the request document that caused the error.

status

string

Status code of the response.

title

string

Short human-readable summary of the error.

{
  "errors": [
    {
      "detail": "Missing required attribute in body",
      "meta": {},
      "source": {
        "header": "Authorization",
        "parameter": "limit",
        "pointer": "/data/attributes/title"
      },
      "status": "400",
      "title": "Bad Request"
    }
  ]
}

Too many requests

API error response.

Expand All

항목

유형

설명

errors [required]

[string]

A list of errors.

{
  "errors": [
    "Bad Request"
  ]
}

코드 예시

                          ## default
# 

# Path parameters
export rule_id="00000000-0000-0000-0000-000000000000"
# Use a Personal Access Token or Service Access Token
export DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>"

# Curl command
curl -X PUT "https://api.ap1.datadoghq.com"https://api.ap2.datadoghq.com"https://api.datadoghq.eu"https://api.ddog-gov.com"https://api.us2.ddog-gov.com"https://api.uk1.datadoghq.com"https://api.datadoghq.com"https://api.us3.datadoghq.com"https://api.us5.datadoghq.com/api/v2/security/findings/automation/inbox_rules/${rule_id}" \ -H "Accept: application/json" \ -H "Content-Type: application/json" \ -H "Authorization: Bearer ${DD_BEARER_TOKEN}" \ -d @- << EOF { "data": { "attributes": { "action": { "description": "Needs triage" }, "enabled": false, "name": "Triage production misconfigurations", "rule": { "finding_types": [ "misconfiguration" ], "query": "env:prod" } }, "id": "00000000-0000-0000-0000-000000000000", "type": "inbox_rules" } } EOF
// Update an inbox rule returns "Successfully updated the inbox rule" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
	"github.com/google/uuid"
)

func main() {
	// there is a valid "valid_inbox_rule" in the system
	ValidInboxRuleDataID := uuid.MustParse(os.Getenv("VALID_INBOX_RULE_DATA_ID"))

	body := datadogV2.InboxRuleUpdateRequest{
		Data: datadogV2.InboxRuleDataUpdate{
			Attributes: datadogV2.InboxRuleAttributesCreate{
				Action: datadogV2.InboxRuleAction{
					Description: datadog.PtrString("Needs triage"),
				},
				Enabled: datadog.PtrBool(false),
				Name:    "Example-Security-Monitoring",
				Rule: datadogV2.AutomationRuleScope{
					FindingTypes: []datadogV2.SecurityFindingType{
						datadogV2.SECURITYFINDINGTYPE_MISCONFIGURATION,
					},
					Query: datadog.PtrString("env:staging"),
				},
			},
			Id:   ValidInboxRuleDataID,
			Type: datadogV2.INBOXRULETYPE_INBOX_RULES,
		},
	}
	ctx := datadog.NewDefaultContext(context.Background())
	ctx = context.WithValue(ctx, datadog.ContextAccessToken, os.Getenv("DD_BEARER_TOKEN"))
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.UpdateSecurityFindingsAutomationInboxRule", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewSecurityMonitoringApi(apiClient)
	resp, r, err := api.UpdateSecurityFindingsAutomationInboxRule(ctx, ValidInboxRuleDataID, body)

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `SecurityMonitoringApi.UpdateSecurityFindingsAutomationInboxRule`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `SecurityMonitoringApi.UpdateSecurityFindingsAutomationInboxRule`:\n%s\n", responseContent)
}

Instructions

First install the library and its dependencies and then save the example to main.go and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" go run "main.go"
// Update an inbox rule returns "Successfully updated the inbox rule" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.SecurityMonitoringApi;
import com.datadog.api.client.v2.model.AutomationRuleScope;
import com.datadog.api.client.v2.model.InboxRuleAction;
import com.datadog.api.client.v2.model.InboxRuleAttributesCreate;
import com.datadog.api.client.v2.model.InboxRuleDataUpdate;
import com.datadog.api.client.v2.model.InboxRuleResponse;
import com.datadog.api.client.v2.model.InboxRuleType;
import com.datadog.api.client.v2.model.InboxRuleUpdateRequest;
import com.datadog.api.client.v2.model.SecurityFindingType;
import java.util.Collections;
import java.util.UUID;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setAccessToken(System.getenv("DD_BEARER_TOKEN"));
    defaultClient.setUnstableOperationEnabled("v2.updateSecurityFindingsAutomationInboxRule", true);
    SecurityMonitoringApi apiInstance = new SecurityMonitoringApi(defaultClient);

    // there is a valid "valid_inbox_rule" in the system
    UUID VALID_INBOX_RULE_DATA_ID = null;
    try {
      VALID_INBOX_RULE_DATA_ID = UUID.fromString(System.getenv("VALID_INBOX_RULE_DATA_ID"));
    } catch (IllegalArgumentException e) {
      System.err.println("Error parsing UUID: " + e.getMessage());
    }

    InboxRuleUpdateRequest body =
        new InboxRuleUpdateRequest()
            .data(
                new InboxRuleDataUpdate()
                    .attributes(
                        new InboxRuleAttributesCreate()
                            .action(new InboxRuleAction().description("Needs triage"))
                            .enabled(false)
                            .name("Example-Security-Monitoring")
                            .rule(
                                new AutomationRuleScope()
                                    .findingTypes(
                                        Collections.singletonList(
                                            SecurityFindingType.MISCONFIGURATION))
                                    .query("env:staging")))
                    .id(VALID_INBOX_RULE_DATA_ID)
                    .type(InboxRuleType.INBOX_RULES));

    try {
      InboxRuleResponse result =
          apiInstance.updateSecurityFindingsAutomationInboxRule(VALID_INBOX_RULE_DATA_ID, body);
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println(
          "Exception when calling SecurityMonitoringApi#updateSecurityFindingsAutomationInboxRule");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}

Instructions

First install the library and its dependencies and then save the example to Example.java and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" java "Example.java"
"""
Update an inbox rule returns "Successfully updated the inbox rule" response
"""

from os import environ
from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.security_monitoring_api import SecurityMonitoringApi
from datadog_api_client.v2.model.automation_rule_scope import AutomationRuleScope
from datadog_api_client.v2.model.inbox_rule_action import InboxRuleAction
from datadog_api_client.v2.model.inbox_rule_attributes_create import InboxRuleAttributesCreate
from datadog_api_client.v2.model.inbox_rule_data_update import InboxRuleDataUpdate
from datadog_api_client.v2.model.inbox_rule_type import InboxRuleType
from datadog_api_client.v2.model.inbox_rule_update_request import InboxRuleUpdateRequest
from datadog_api_client.v2.model.security_finding_type import SecurityFindingType

# there is a valid "valid_inbox_rule" in the system
VALID_INBOX_RULE_DATA_ID = environ["VALID_INBOX_RULE_DATA_ID"]

body = InboxRuleUpdateRequest(
    data=InboxRuleDataUpdate(
        attributes=InboxRuleAttributesCreate(
            action=InboxRuleAction(
                description="Needs triage",
            ),
            enabled=False,
            name="Example-Security-Monitoring",
            rule=AutomationRuleScope(
                finding_types=[
                    SecurityFindingType.MISCONFIGURATION,
                ],
                query="env:staging",
            ),
        ),
        id=VALID_INBOX_RULE_DATA_ID,
        type=InboxRuleType.INBOX_RULES,
    ),
)

configuration = Configuration()
configuration.access_token = environ["DD_BEARER_TOKEN"]
configuration.unstable_operations["update_security_findings_automation_inbox_rule"] = True
with ApiClient(configuration) as api_client:
    api_instance = SecurityMonitoringApi(api_client)
    response = api_instance.update_security_findings_automation_inbox_rule(rule_id=VALID_INBOX_RULE_DATA_ID, body=body)

    print(response)

Instructions

First install the library and its dependencies and then save the example to example.py and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" python3 "example.py"
# Update an inbox rule returns "Successfully updated the inbox rule" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.access_token = ENV["DD_BEARER_TOKEN"]
  config.unstable_operations["v2.update_security_findings_automation_inbox_rule".to_sym] = true
end
api_instance = DatadogAPIClient::V2::SecurityMonitoringAPI.new

# there is a valid "valid_inbox_rule" in the system
VALID_INBOX_RULE_DATA_ID = ENV["VALID_INBOX_RULE_DATA_ID"]

body = DatadogAPIClient::V2::InboxRuleUpdateRequest.new({
  data: DatadogAPIClient::V2::InboxRuleDataUpdate.new({
    attributes: DatadogAPIClient::V2::InboxRuleAttributesCreate.new({
      action: DatadogAPIClient::V2::InboxRuleAction.new({
        description: "Needs triage",
      }),
      enabled: false,
      name: "Example-Security-Monitoring",
      rule: DatadogAPIClient::V2::AutomationRuleScope.new({
        finding_types: [
          DatadogAPIClient::V2::SecurityFindingType::MISCONFIGURATION,
        ],
        query: "env:staging",
      }),
    }),
    id: VALID_INBOX_RULE_DATA_ID,
    type: DatadogAPIClient::V2::InboxRuleType::INBOX_RULES,
  }),
})
p api_instance.update_security_findings_automation_inbox_rule(VALID_INBOX_RULE_DATA_ID, body)

Instructions

First install the library and its dependencies and then save the example to example.rb and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" rb "example.rb"
// Update an inbox rule returns "Successfully updated the inbox rule" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_security_monitoring::SecurityMonitoringAPI;
use datadog_api_client::datadogV2::model::AutomationRuleScope;
use datadog_api_client::datadogV2::model::InboxRuleAction;
use datadog_api_client::datadogV2::model::InboxRuleAttributesCreate;
use datadog_api_client::datadogV2::model::InboxRuleDataUpdate;
use datadog_api_client::datadogV2::model::InboxRuleType;
use datadog_api_client::datadogV2::model::InboxRuleUpdateRequest;
use datadog_api_client::datadogV2::model::SecurityFindingType;

#[tokio::main]
async fn main() {
    // there is a valid "valid_inbox_rule" in the system
    let valid_inbox_rule_data_id =
        uuid::Uuid::parse_str(&std::env::var("VALID_INBOX_RULE_DATA_ID").unwrap())
            .expect("Invalid UUID");
    let body = InboxRuleUpdateRequest::new(InboxRuleDataUpdate::new(
        InboxRuleAttributesCreate::new(
            InboxRuleAction::new().description("Needs triage".to_string()),
            "Example-Security-Monitoring".to_string(),
            AutomationRuleScope::new(vec![SecurityFindingType::MISCONFIGURATION])
                .query("env:staging".to_string()),
        )
        .enabled(false),
        valid_inbox_rule_data_id.clone(),
        InboxRuleType::INBOX_RULES,
    ));
    let mut configuration = datadog::Configuration::new();
    configuration
        .set_unstable_operation_enabled("v2.UpdateSecurityFindingsAutomationInboxRule", true);
    let api = SecurityMonitoringAPI::with_config(configuration);
    let resp = api
        .update_security_findings_automation_inbox_rule(valid_inbox_rule_data_id.clone(), body)
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}

Instructions

First install the library and its dependencies and then save the example to src/main.rs and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
/**
 * Update an inbox rule returns "Successfully updated the inbox rule" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration({
  authMethods: {
    AuthZ: {
      accessToken: process.env.DD_BEARER_TOKEN as string,
    },
  },
});
configuration.unstableOperations[
  "v2.updateSecurityFindingsAutomationInboxRule"
] = true;
const apiInstance = new v2.SecurityMonitoringApi(configuration);

// there is a valid "valid_inbox_rule" in the system
const VALID_INBOX_RULE_DATA_ID = process.env.VALID_INBOX_RULE_DATA_ID as string;

const params: v2.SecurityMonitoringApiUpdateSecurityFindingsAutomationInboxRuleRequest =
  {
    body: {
      data: {
        attributes: {
          action: {
            description: "Needs triage",
          },
          enabled: false,
          name: "Example-Security-Monitoring",
          rule: {
            findingTypes: ["misconfiguration"],
            query: "env:staging",
          },
        },
        id: VALID_INBOX_RULE_DATA_ID,
        type: "inbox_rules",
      },
    },
    ruleId: VALID_INBOX_RULE_DATA_ID,
  };

apiInstance
  .updateSecurityFindingsAutomationInboxRule(params)
  .then((data: v2.InboxRuleResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));

Instructions

First install the library and its dependencies and then save the example to example.ts and run following commands:

    
DD_SITE="datadoghq.comus3.datadoghq.comus5.datadoghq.comdatadoghq.euap1.datadoghq.comap2.datadoghq.comuk1.datadoghq.comddog-gov.comus2.ddog-gov.com" DD_BEARER_TOKEN="<PERSONAL_ACCESS_TOKEN OR SERVICE_ACCESS_TOKEN>" tsc "example.ts"